 
extern void reserve(int x);
extern void use(int x);
extern void check_permission(int n);
extern void downgrade(void);

__asm("\nANN_STARTLF\nIMPORT mach.ans docomo.ans \nANN_ENDLF\n");


__asm("ANN_FUNCTION(_test1, %LF_true%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            0, 8)");

int test1() {
  int i;
  check_permission(1);
  // upgrade();
  reserve(8);
  use(7);
}

__asm("ANN_FUNCTION(_test2, %LF_(> perms 0)%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            0, 8)");

int test2() {
  int i;
  reserve(8);
  use(3);
  use(2);
}


__asm("ANN_FUNCTION(_test3, %LF_(> perms 0)%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            2, 8)");

int test3(int n) {
  int i;
  reserve(9);
  __asm("\nLdom1:\n\tANN_DOMINATOR\n");
  if(n) {
    use(5);
  } else {
    use(4);
  }
  __asm("ANN_INV(Ldom1,\n\
                 %LF_(>= quota 4)%_LF,\n\
                 RB(ESP,EBP,FTOP,loc3,loc4,perms))");
  use(4);
}


__asm("ANN_FUNCTION(_test4, %LF_(/\\ (>= loc1 0) \n\
                                    (> perms 0))%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            1, 8)");
 
int test4(int n) {
  int i;
  reserve(n);
  i = 0;
  do {
    __asm__ volatile ("ANN_INV(ANN_DOM_LOOP,\n\
                   %%LF_(/\\ (>= quota (- eax edx)) \n\
                             (>= quota 0))%%_LF,\n\
                   RB(EBP,ESP,FTOP,loc1,loc2,loc3,eax,perms))"
                      : "=d" (i) : "a" (n), "d" (i));
    if(i >= n) break;
    use(1);
    i ++;
  } while(1);
}


// We try the same example but the reserved value is an expression
__asm("ANN_FUNCTION(_test5, %LF_(/\\ (>= quota 0)\n \
                                (/\\ (>= loc1 0)\n \
                                     (> perms 0)))%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            1, 8)");

int test5(int n) {
  int i;
  reserve(n + 5);
  i = 0;
  do {
    __asm__ volatile ("ANN_INV(ANN_DOM_LOOP,\n\
                   %%LF_(/\\ (>= quota (- (+ eax 5) edx))\n\
                             (>= quota 0))%%_LF,\n\
                   RB(EBP,ESP,FTOP,loc1,loc2,loc3,eax,perms))"
                      : "=d" (i) : "a" (n), "d" (i));
    if(i >= n + 5) break;
    use(1);
    i ++;
    __asm__ ("ANN_COMMENT(I am at the end of the iteration)");
  } while(1);
}

__asm("ANN_FUNCTION(_test6, %LF_(>= loc1 0)%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            1, 16)");

int test6(int n) {
  int i, j;
  check_permission (1);
  
  reserve(n + n);
  i = 0;
  do {
    __asm__ volatile ("ANN_INV(ANN_DOM_LOOP,\n\
                   %%LF_(/\\ (>= quota (- (* eax 2) (* edx 2)))\n\
                             (<= edx eax))%%_LF,\n\
                   RB(EBP,ESP,FTOP,loc1,loc2,loc3,eax,perms))"
                      : "=d" (i) : "a" (n), "d" (i));
    if(i >= n) break;

    j = 0;
    do {
       __asm__ volatile ("ANN_INV(ANN_DOM_LOOP,\n\
                   %%LF_(/\\ (>= quota (- (* eax 2)\n\
                                          (+ (* edx 2) esi)))\n\
                        (/\\ (>= esi 0)\n \
                             (<= esi 2)))%%_LF,\n\
                   RB(EBP,ESP,FTOP,loc1,loc2,loc3,eax,edx,perms))"
                      : "=d" (i), "=S" (j)
                      : "a" (n), "d" (i), "S" (j));
      if(j >= 2) break;
      use(1);
      j++;
      
    } while(1);
    i ++;
  } while(1);
}


///////////// DOWNGRADE

__asm("ANN_FUNCTION(_test10, %LF_true%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            0, 8)");
int test10() {
  int i;
  check_permission(1);
  reserve(8);
  use(7);
}


__asm("ANN_FUNCTION(_test11,%LF_true%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP, perms),\n \
                            0, 8)");
int test11() {
  int i;

  check_permission(1);
  reserve(7);
  use(7);
  

}


__asm("ANN_FUNCTION(_test12,%LF_true%_LF,\n \
                            %LF_(>= perms 0)%_LF,\n \
                            RB(ESP, EBP, FTOP),\n \
                            0, 8)");
int test12() {
  int i;
  check_permission(1);
  downgrade();
  test11(); // Call test11 without permissions
  upgrade();  
  reserve(8);
  use(7);
  downgrade();
}


__asm("ANN_FUNCTION(_test13,%LF_(= perms 0)%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP, perms),\n \
                            0, 8)");
int test13() {
  int i;
  upgrade(); // I should not be able to call test11 after I
             // upgraded
  // test11(); 
  downgrade();

  reserve(8);
  // use(7); // Should fail
}

__asm("ANN_FUNCTION(_test14,%LF_true%_LF,\n \
                            %LF_true%_LF,\n \
                            RB(ESP, EBP, FTOP, perms),\n \
                            1, 8)");
int test14(int n) {
  int i;
  if(n) {
    check_permission(1);
  }
  reserve(7);
  // use(7); // Should fail if n == 0
}
